﻿<AML>
 <Item type="Method" id="367382210A9C41DDBC0FE5908D67A42D" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_AR_Bulk_call
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                When we do Post To GL,
                -Getting Required Information to add Journal as "Account Receivable" Transaction Type and CashBook.

            Hooks:
                Called by:	acc_AR_Post_to_GL

            Inputs:
                id,
                acc_date,
                acc_customer,
                acc_cash_account,
                acc_currency,
                acc_rate,
                acc_operator,
                acc_reference_no

            Revisions:
                Rev Date		Modified By			Description
                2018-07-16		Chan				When we do Post To GL for SGD Receivable Bill, wrong Journal Entry.
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_AR_Bulk_call﻿";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                string acc_fcashbookamount = "";
                var receivable_account = "";
                var _cash = "";
                var _systemname = "";
                var _exchange_gain_loss_id = "";
                var _gainloss_systemname = "";
                string _gainloss_console = "";
                decimal _sop_cr_dr_payment = 0;
                decimal _total_diff_crdr_payment = 0;
                decimal _d_loss = 0;
                decimal _d_gain = 0;
                string _gain_loss = "";
                var _gain_loss_currency = "";
                string acc_console = "";
                string acc_ar_cashbook = "";
                string _headerid = "";
                string _cashbook_header_id = "";
                decimal _cr_dr_payment = 0;
                decimal _cr_dr_cash = 0;
                decimal _cr_dr_receivable = 0;

                decimal _cr_dr_sg_receivable = 0;
                decimal _cr_dr_sg_cash = 0;
                decimal _d_sg_loss = 0;
                decimal _d_sg_gain = 0;

                string acc_project = "";
                string acc_department = "";
                string acc_currencycode = "";
                var sop_invoice_date = "";
                var sop_owing_amount = "";
                decimal acc_ftotal = 0;
                decimal acc_result_owing = 0;

                /* <Added by THS for AfterAddMethod>*/
                var _id = this.getProperty("id");
                var _acc_date = this.getProperty("acc_date");
                var _acc_customer = this.getProperty("acc_customer");
                var _acc_refno = this.getProperty("acc_reference_no");
                acc_ar_cashbook = this.getProperty("acc_cash_account");
                var acc_ar_currency = this.getProperty("acc_currency");
                var acc_ar_rate = this.getProperty("acc_rate");
                decimal acc_ar_frate = Convert.ToDecimal(acc_ar_rate);
                var acc_ar_operator = this.getProperty("acc_operator");
                /* <Added by THS for AfterAddMethod>*/

                decimal acc_fpayment = 0;
                Item ar_detail_item = myInnovator.newItem("acc_AccountsReceivableDetail", "get");
                ar_detail_item.setProperty("source_id", _id);
                ar_detail_item.setPropertyCondition("source_id", "eq");
                ar_detail_item.setProperty("acc_payment", "0");
                ar_detail_item.setPropertyCondition("acc_payment", "gt");
                Item result_ap = ar_detail_item.apply();

                var ar_count = result_ap.getItemCount();

                if (ar_count > 0)
                {
                    int i;
                    for (i = 0; i < ar_count; i++)
                    {
                        var acc_ar_item = result_ap.getItemByIndex(i);
                        string acc_pay_check = acc_ar_item.getProperty("acc_pay_check");
                        if (acc_pay_check == "1")
                        {
                            string acc_ar_detail_id = acc_ar_item.getProperty("id");
                            string acc_invoice_id = acc_ar_item.getProperty("acc_invoice_id");
                            string acc_invoice_no = acc_ar_item.getProperty("acc_invoice_no");
                            string acc_payment_description = acc_ar_item.getProperty("acc_payment_description");

                            string acc_owing = acc_ar_item.getProperty("acc_exchange_owing");
                            decimal acc_fowing = Convert.ToDecimal(acc_owing);

                            string acc_payment = acc_ar_item.getProperty("acc_payment");
                            acc_fpayment = Convert.ToDecimal(acc_payment);

                            string acc_ttotal = acc_ar_item.getProperty("acc_exchange_amount");                          
                            string acc_sop_currency = acc_ar_item.getProperty("acc_sop_currency");                            
                            decimal acc_result_payment = acc_fpayment;

                            //check if base currency
                            var l_base_currency = myInnovator.newItem("acc_currency", "get");
                            l_base_currency.setProperty("acc_isdefault", "1");
                            l_base_currency.setProperty("id", acc_ar_currency);
                            var l_bcurrency_result = l_base_currency.apply();
                            var l_bcurrency_count = l_bcurrency_result.getItemCount();
                            /*Start for base credit and debit*/

                            if (l_bcurrency_count > 0)
                            {
                                _cr_dr_payment = acc_fpayment;
                                _cr_dr_cash = Math.Round(_cr_dr_payment, 2);
                                _cr_dr_receivable = Math.Round(_cr_dr_payment, 2);
                            }
                            //yyk01 calculate amount currency change other to base
                            else
                            {

                                if (acc_ar_operator == "*")
                                {
                                    _cr_dr_payment = acc_fpayment / acc_ar_frate;
                                    _cr_dr_cash = Math.Round(_cr_dr_payment, 2);
                                    _cr_dr_receivable = Math.Round(_cr_dr_payment, 2);
                                }
                                else
                                {
                                    _cr_dr_payment = acc_fpayment * acc_ar_frate;
                                    _cr_dr_cash = Math.Round(_cr_dr_payment, 2);
                                    _cr_dr_receivable = Math.Round(_cr_dr_payment, 2);
                                }

                            }
                            /*Start for base credit and debit*/

                            //yyk02 calculate amount with previous currency rate to get differecnce currency
                            Item select_sale = myInnovator.applySQL(
                                "SELECT * from innovator.[SOP_Sale_INVOICE]" +
                                " WHERE id='" + acc_invoice_id + "'");
                            if (select_sale.getItemCount() > 0)
                            {
                                acc_project = select_sale.getProperty("acc_project", "");
                                acc_department = select_sale.getProperty("acc_department", "");
                                _acc_customer = select_sale.getProperty("sop_customer", "");//
                                sop_invoice_date = select_sale.getProperty("sop_invoice_date", "");
                                sop_owing_amount = select_sale.getProperty("sop_owing_amount", "");
                                acc_ftotal = Convert.ToDecimal(sop_owing_amount);
                                acc_result_owing = acc_ftotal - acc_fpayment;

                                var acc_sale_operator = "";
                                var acc_sale_rate = "";
                                //get currency rate when we did it invoice
                                var l_sale_currency_rate = myInnovator.applyMethod("acc_currency_info", "<currency_id>" + acc_ar_currency + "</currency_id><currency_date>" + sop_invoice_date + "</currency_date>");
                                var l_sale_currency_rate_count = l_sale_currency_rate.getItemCount();
                                if (l_sale_currency_rate_count > 0)
                                {
                                    acc_currencycode = l_sale_currency_rate.getProperty("acc_currencycode");
                                    acc_sale_operator = l_sale_currency_rate.getProperty("acc_operator");
                                    acc_sale_rate = l_sale_currency_rate.getProperty("acc_monthly_rate");
                                }

                                decimal d_acc_sale_rate = Convert.ToDecimal(acc_sale_rate);
                                if (acc_sale_operator == "*")
                                {
                                    _sop_cr_dr_payment = acc_fpayment / d_acc_sale_rate;
                                }
                                else
                                {
                                    _sop_cr_dr_payment = acc_fpayment * d_acc_sale_rate;
                                }
                            }
                            if (_cr_dr_payment != _sop_cr_dr_payment)
                            {
                                _total_diff_crdr_payment = _cr_dr_payment - _sop_cr_dr_payment;
                                _total_diff_crdr_payment = Math.Abs(_total_diff_crdr_payment);
                                if (_cr_dr_payment < _sop_cr_dr_payment)
                                {
                                    // loss                                    
                                    _d_loss = Math.Round(_sop_cr_dr_payment, 2) - Math.Round(_cr_dr_cash, 2);
                                    _total_diff_crdr_payment = _d_loss;
                                }
                                else
                                {
                                    //gain                                  
                                    _d_gain = Math.Round(_cr_dr_cash, 2) - Math.Round(_sop_cr_dr_payment, 2);
                                    _total_diff_crdr_payment = _d_gain;
                                    _cr_dr_receivable = _cr_dr_cash - _d_gain;

                                }
                            }
                            //yyk02 calculate amount with previous currency rate to get differecnce currency end

                            /*==convert to SG currency(Base to SG)==*/
                            //get SG rate

                            var ar_currency_result = myInnovator.applyMethod("acc_SG_currency_info", "<currency_date>" + sop_invoice_date + "</currency_date>");
                            var ar_currency_count = ar_currency_result.getItemCount();
                            if (ar_currency_count > 0)
                            {
                                string ar_sg_rate = ar_currency_result.getProperty("acc_monthly_rate", "");
                                string ar_sg_operator = ar_currency_result.getProperty("acc_operator", "");
                                if (ar_sg_operator == "*")
                                {
                                    _cr_dr_sg_receivable = Convert.ToDecimal(_cr_dr_receivable) * Convert.ToDecimal(ar_sg_rate);
                                }
                                else
                                {
                                    _cr_dr_sg_receivable = Convert.ToDecimal(_cr_dr_receivable) / Convert.ToDecimal(ar_sg_rate);
                                }
                            }

                            var currency_result = myInnovator.applyMethod("acc_SG_currency_info", "<currency_date>" + _acc_date + "</currency_date>");

                            var currency_count = currency_result.getItemCount();
                            if (currency_count > 0)
                            {
                                string sg_rate = currency_result.getProperty("acc_monthly_rate", "");
                                string sg_operator = currency_result.getProperty("acc_operator", "");
                                if (sg_operator == "*")
                                {
                                    _cr_dr_sg_cash = Convert.ToDecimal(_cr_dr_cash) * Convert.ToDecimal(sg_rate);
                                    _d_sg_loss = Convert.ToDecimal(_d_loss) * Convert.ToDecimal(sg_rate);
                                    _d_sg_gain = Convert.ToDecimal(_d_gain) * Convert.ToDecimal(sg_rate);
                                }
                                else
                                {
                                    _cr_dr_sg_cash = Convert.ToDecimal(_cr_dr_cash) / Convert.ToDecimal(sg_rate);
                                    _d_sg_loss = Convert.ToDecimal(_d_loss) / Convert.ToDecimal(sg_rate);
                                    _d_sg_gain = Convert.ToDecimal(_d_gain) / Convert.ToDecimal(sg_rate);
                                }
                            }

                            /*==convert to SG currency(Base to SG)==*/
                            if (acc_ar_currency != acc_sop_currency)//if not equal we need to transfer to sop_currrency to subtract owing
                            {
                                if (acc_ar_operator == "*")
                                {
                                    acc_result_owing = acc_result_owing / acc_ar_frate;
                                    acc_result_payment = acc_result_payment / acc_ar_frate;     
                                }
                                else
                                {
                                    acc_result_owing = acc_result_owing * acc_ar_frate;
                                    acc_result_payment = acc_result_payment * acc_ar_frate;
                                }
                            }
                            if (acc_result_owing > 0)
                            {
                                Item update_purchase = myInnovator.applySQL("UPDATE innovator.[SOP_SALE_INVOICE]" +
                                    " SET  sop_owing_amount=" + acc_result_owing + "," +
                                    " sop_payment_amount+=" + acc_result_payment + "," +
                                    " pop_invoice_status = 'Partial PAID' " +
                                    "  WHERE id='" + acc_invoice_id + "'");
                            }
                            else
                            {
                                Item update_purchase = myInnovator.applySQL("UPDATE innovator.[SOP_SALE_INVOICE]" +
                                         " SET  sop_owing_amount=" + acc_result_owing + "," +
                                         " sop_payment_amount+=" + acc_result_payment + "," +
                                         " pop_invoice_status = 'PAID' " +
                                         "  WHERE id='" + acc_invoice_id + "'");
                            }

                            Item cashbook_amount = myInnovator.applySQL("UPDATE innovator.[acc_AccountDetails]" +
                                " SET  acc_amount +=" + acc_payment +
                                " WHERE id='" + acc_ar_cashbook + "'");

                            Item result_cashbook_amt = myInnovator.applySQL("SELECT * FROM  innovator.[acc_AccountDetails] WHERE  id ='" + acc_ar_cashbook + "'");
                            var result_cashbook_count = result_cashbook_amt.getItemCount();
                            if (result_cashbook_count > 0)
                            {
                                var acc_cashbook_amt = result_cashbook_amt.getItemByIndex(0);
                                acc_fcashbookamount = acc_cashbook_amt.getProperty("acc_amount");
                            }

                            //for journal posting sections

                            // Get Account Receivable from Company Setup 
                            var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
                            var ar_result = erp_company_setup.apply();
                            var ar_result_count = ar_result.getItemCount();
                            if (ar_result_count > 0)
                            {
                                var setup = ar_result.getItemByIndex(0);
                                receivable_account = setup.getProperty("erp_ar_account", "");
                                _exchange_gain_loss_id = setup.getProperty("erp_exchange_gainandloss");

                            }
                            //for gain and loss
                            if (_d_gain != 0 || _d_loss != 0)
                            {
                                Item result_GainLoss_account = myInnovator.applySQL(
                               "SELECT * FROM  innovator.[ACC_ACCOUNTDETAILS]" +
                               " WHERE id ='" + _exchange_gain_loss_id + "'");
                                var result_GainLoss_account_count = result_GainLoss_account.getItemCount();
                                if (result_GainLoss_account_count > 0)
                                {
                                    var _GainLoss_account = result_GainLoss_account.getItemByIndex(0);
                                    _gainloss_console = _GainLoss_account.getProperty("acc_accountconsole");
                                    _gainloss_systemname = _gainloss_console;
                                    _gain_loss = _GainLoss_account.getProperty("id");
                                    _gain_loss_currency = _GainLoss_account.getProperty("acc_currency");
                                }
                            }

                            Item result_account = myInnovator.applySQL("SELECT * FROM  innovator.[ACC_ACCOUNTDETAILS]" +
                                " WHERE  id ='" + acc_ar_cashbook + "'");
                            var result_count = result_account.getItemCount();
                            if (result_count > 0)
                            {
                                var acc_account = result_account.getItemByIndex(0);
                                acc_console = acc_account.getProperty("acc_accountconsole");
                                _systemname = acc_console;
                                _cash = acc_account.getProperty("id");
                            }
                            
                            Item acc_ledger_header = myInnovator.newItem("acc_journal_header", "add");
                            acc_ledger_header.setProperty("acc_date", _acc_date);
                            acc_ledger_header.setProperty("acc_reftransactionid", _id);
                            acc_ledger_header.setProperty("acc_transactiontype", "Account Receivable");
                            acc_ledger_header.setProperty("acc_customerid", _acc_customer);
                            acc_ledger_header.setProperty("acc_refno", _acc_refno);
                            acc_ledger_header.setProperty("acc_amount", Convert.ToString(_cr_dr_payment));
                            acc_ledger_header.setProperty("acc_credit_amount", Convert.ToString(_cr_dr_payment));
                            acc_ledger_header.setProperty("acc_sop_voucher_reference", acc_invoice_id);
                            if (acc_project != "")
                            {
                                acc_ledger_header.setProperty("acc_project", acc_project);
                            }

                            if (acc_department != "")
                            {
                                acc_ledger_header.setProperty("acc_department", acc_department);
                            }

                            acc_ledger_header.apply();
                            _headerid = acc_ledger_header.getID();
                            if (acc_ledger_header.isError())
                            {
                                return myInnovator.newError("Error In Save1: " + acc_ledger_header.getErrorDetail());
                            }
                           
                            Item acc_accountdetail_cash_item = myInnovator.getItemById("acc_AccountDetails", _cash);


                            Item acc_ledger_detail_dr = myInnovator.newItem("acc_journal_details", "add");
                            acc_ledger_detail_dr.setProperty("acc_accountid", receivable_account);
                            Item acc_accountdetail_rec_item = myInnovator.getItemById("acc_AccountDetails", receivable_account);

                            acc_ledger_detail_dr.setProperty("acc_accountdetail_code", acc_accountdetail_rec_item.getProperty("acc_accountdetail_code", ""));
                            acc_ledger_detail_dr.setProperty("acc_debit", "0");

                            acc_ledger_detail_dr.setProperty("acc_credit", Convert.ToString(Math.Round(_sop_cr_dr_payment, 2)));

                            acc_ledger_detail_dr.setProperty("acc_sg_debit", "0");


                            if (acc_currencycode == "SGD")
                            {
                                acc_ledger_detail_dr.setProperty("acc_sg_credit", Convert.ToString(acc_fpayment));
                            }
                            else
                            {
                                acc_ledger_detail_dr.setProperty("acc_sg_credit", Convert.ToString(_cr_dr_sg_receivable));
                            }
                            acc_ledger_detail_dr.setProperty("acc_systemaccountid", "Account Receivable");
                            acc_ledger_detail_dr.setProperty("acc_currency", acc_ar_currency);
                            acc_ledger_detail_dr.setProperty("acc_amount_currency", Convert.ToString(acc_fpayment));
                            acc_ledger_detail_dr.setProperty("acc_description", acc_payment_description + "_Cah/Bank" + acc_accountdetail_cash_item.getProperty("acc_accountdetail_code", ""));
                            acc_ledger_detail_dr.setProperty("source_id", _headerid);
                            acc_ledger_detail_dr.apply();

                            Item acc_ledger_detail_cr = myInnovator.newItem("acc_journal_details", "add");
                            acc_ledger_detail_cr.setProperty("acc_accountid", _cash);


                            acc_ledger_detail_cr.setProperty("acc_accountdetail_code", acc_accountdetail_cash_item.getProperty("acc_accountdetail_code", ""));
                            acc_ledger_detail_cr.setProperty("acc_debit", Convert.ToString(_cr_dr_cash));
                            acc_ledger_detail_cr.setProperty("acc_credit", "0");
                            if (acc_currencycode == "SGD")
                            {
                                acc_ledger_detail_cr.setProperty("acc_sg_debit", Convert.ToString(acc_fpayment));
                            }
                            else
                            {
                                acc_ledger_detail_cr.setProperty("acc_sg_debit", Convert.ToString(_cr_dr_sg_cash));
                            }

                            acc_ledger_detail_cr.setProperty("acc_sg_credit", "0");
                            acc_ledger_detail_cr.setProperty("acc_systemaccountid", _systemname);
                            acc_ledger_detail_cr.setProperty("acc_currency", acc_ar_currency);
                            acc_ledger_detail_cr.setProperty("acc_amount_currency", Convert.ToString(acc_fpayment));
                            acc_ledger_detail_cr.setProperty("acc_description", _acc_refno);
                            acc_ledger_detail_cr.setProperty("source_id", _headerid);
                            acc_ledger_detail_cr.apply();
                            if (_d_gain != 0 || _d_loss != 0)
                            {
                                Item detailsGainLoss = myInnovator.newItem("acc_journal_details", "add");
                                detailsGainLoss.setProperty("acc_accountid", _gain_loss);
                                Item acc_accountdetail_gain_item = myInnovator.getItemById("acc_AccountDetails", _gain_loss);

                                detailsGainLoss.setProperty("acc_accountdetail_code", acc_accountdetail_gain_item.getProperty("acc_accountdetail_code", ""));
                                detailsGainLoss.setProperty("acc_debit", Convert.ToString(_d_loss));
                                detailsGainLoss.setProperty("acc_credit", Convert.ToString(_d_gain));
                                detailsGainLoss.setProperty("acc_sg_debit", Convert.ToString(_d_sg_loss));
                                detailsGainLoss.setProperty("acc_sg_credit", Convert.ToString(_d_sg_gain));
                                detailsGainLoss.setProperty("acc_systemaccountid", _gainloss_systemname);
                                detailsGainLoss.setProperty("acc_currency", _gain_loss_currency);
                                detailsGainLoss.setProperty("acc_description", "Exchange Gain/Loss: " + _acc_refno);
                                detailsGainLoss.setProperty("acc_amount_currency", Convert.ToString(_total_diff_crdr_payment));
                                detailsGainLoss.setProperty("source_id", _headerid);
                                detailsGainLoss.apply();

                            }


                            //save or update to cashbook header and detail
                            Item acc_cashbook_header = myInnovator.newItem("acc_cashbook", "get");
                            acc_cashbook_header.setProperty("acc_cashbook", _cash);
                            acc_cashbook_header = acc_cashbook_header.apply();
                            var cashbook_count = acc_cashbook_header.getItemCount();
                            if (cashbook_count < 1)
                            {
                                Item acc_cashbook_add = myInnovator.newItem("acc_cashbook", "add");
                                acc_cashbook_add.setProperty("acc_cashbook", _cash);
                                acc_cashbook_add.setProperty("acc_date", DateTime.Now.ToString("yyyy-MM-dd"));
                                acc_cashbook_add.apply();
                                _cashbook_header_id = acc_cashbook_add.getID();

                                decimal acc_dcashbookamount = Convert.ToDecimal(acc_fcashbookamount);
                                decimal acc_dpayment = Convert.ToDecimal(acc_payment);
                                decimal d_result = acc_dcashbookamount - acc_dpayment;

                                Item acc_cashbook_Detail_OP = myInnovator.newItem("ACC_CASHBOOKDETAIL", "add");
                                acc_cashbook_Detail_OP.setProperty("acc_account_code", _cash);
                                acc_cashbook_Detail_OP.setProperty("acc_income", Convert.ToString(d_result));
                                acc_cashbook_Detail_OP.setProperty("acc_transaction_date", _acc_date);
                                acc_cashbook_Detail_OP.setProperty("acc_transaction_type", "CashBook Opening");
                                acc_cashbook_Detail_OP.setProperty("source_id", _cashbook_header_id);
                                acc_cashbook_Detail_OP.apply();
                            }
                            else
                            {
                                _cashbook_header_id = acc_cashbook_header.getProperty("id");
                            }

                            Item acc_cashbook_Detail = myInnovator.newItem("ACC_CASHBOOKDETAIL", "add");
                            acc_cashbook_Detail.setProperty("acc_account_code", receivable_account);
                            acc_cashbook_Detail.setProperty("acc_customer", _acc_customer);
                            acc_cashbook_Detail.setProperty("acc_income", Convert.ToString(acc_fpayment));
                            acc_cashbook_Detail.setProperty("acc_transaction_code", _acc_refno);
                            acc_cashbook_Detail.setProperty("acc_transaction_id", _id);
                            acc_cashbook_Detail.setProperty("acc_transaction_date", _acc_date);
                            acc_cashbook_Detail.setProperty("acc_transaction_type", "Account Receivable");
                            acc_cashbook_Detail.setProperty("source_id", _cashbook_header_id);
                            acc_cashbook_Detail.apply();
                            //cashbook adding finish
                            Item acc_cashbook_balance = myInnovator.applySQL("UPDATE innovator.[acc_cashbook]" +
                                " SET  acc_date='" + DateTime.Now.ToString("yyyy-MM-dd") + "'," +
                                " acc_cashbook_balance=" + acc_fcashbookamount +
                                " WHERE acc_cashbook='" + _cash + "'");
                        }
                    }


                    Item update_ap = myInnovator.applySQL("UPDATE innovator.[ACC_ACCOUNTSRECEIVABLE]" +
                        " SET  acc_ispost=" + 1 +
                        " WHERE id='" + _id + "'");

                    Item dele_ar_detail = myInnovator.applySQL("DELETE FROM  innovator.[ACC_ACCOUNTSRECEIVABLEDETAIL]" +
                        " WHERE source_id='" + _id + "'" +
                        " AND (ACC_PAYMENT is null OR ACC_PAYMENT=0 )");

                }

            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_AR_Bulk_call</name>
 </Item>
</AML>